#!/usr/local/bin/perl

############################################################
#BooPasswordManager v1.14 / This program is value software.#
#(C) BooBooClub 1999-2012                                  #
############################################################

#set_data
$adpass = 'pass';
$htpasswd = './.htpasswd';
$bgcolor = '#779977';
$tdbgcolor = '#99aa99';
$oneline = '3';
$sortid = 'abc';



#read
if ($ENV{'REQUEST_METHOD'} eq "POST"){
	read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
}
else{
	$buffer = $ENV{'QUERY_STRING'};
}

@pairs = split(/&/,$buffer);
foreach $pair (@pairs) {
	($name, $value) = split(/=/, $pair);
	$value =~ tr/+/ /;
	$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	$value =~ s/\r\n|[\r\n]//ig;
	$FORM{$name} = $value;
}


#lock
&lock;



#allow

if($FORM{'regist'}){
	&check;
	&regist;
}
elsif($FORM{'remove'}){
	&check;
	&remove;
}
elsif($FORM{'change'}){
	&check;
	&change;
}
else{
	&html;
}



sub check{
	if(!$FORM{'remove'}){
		if($FORM{'id'} eq '' || $FORM{'pass'} eq '' 
		|| $FORM{'id'} =~ /\W/ || $FORM{'pass'} =~ /\W/){
			&error;
		}
	}
	if($FORM{'adpass'} ne $adpass){
		&pass_error;
	}
}



sub regist{
	open (USER,"$htpasswd");
	@user = <USER>;
	close (USER);
	foreach $user(@user){
		($uid,$d) = split(/:/,$user);
		if($uid eq $FORM{'id'}){
			&error;
		}
	}
	srand(time|$$);
	@saltset = ('a' .. 'z', 'A' .. 'Z', '0' .. '9', '.', '/');
	$salt = $saltset[int(rand(64))] . $saltset[int(rand(64))];
	$passwd = crypt($FORM{'pass'},$salt);
	if($passwd eq crypt($FORM{'pass'},$passwd)){
		$npass = "$FORM{'id'}:$passwd\n";
		open (USER,">>$htpasswd");
		print USER $npass;
		close (USER);
		&html;
	}
	else{
		&passreg_error;
	}
}



sub remove{
	open (USER,"$htpasswd");
	@pw = <USER>;
	close (USER);
	foreach $pw(@pw){
		($id,$cpass) = split(/:/,$pw);
		if(!$FORM{$id}){
			push (@npw,$pw);
		}
	}
	open (USER,">$htpasswd");
	print USER @npw;
	close (USER);
	&html;
}



sub change{
	open (USER,"$htpasswd");
	@ud = <USER>;
	close (USER);
	foreach $ud(@ud){
		($id,$cpass) = split(/:/,$ud);
		if($id eq $FORM{'id'}){
			srand(time|$$);
			@saltset = ('a' .. 'z', 'A' .. 'Z', '0' .. '9', '.', '/');
			$salt = $saltset[int(rand(64))] . $saltset[int(rand(64))];
			$passwd = crypt($FORM{'pass'},$salt);
			if($passwd eq crypt($FORM{'pass'},$passwd)){
				$npass = "$id:$passwd\n";
				push (@nud,$npass);
			}
			else{
				$passreg_error;
			}
		}
		else{
			push(@nud,$ud);
		}
	}
	open (USER,">$htpasswd");
	print USER @nud;
	close (USER);
	&html;
}



sub html {
	print "Content-type: text/html\n\n";
	print '<html>'."\n";
	print '<head>'."\n";
	print '<meta http-equiv="content-type" content="text/html; charset=Shift_JIS">'."\n";
	print '<title>BooPasswordManager</title>'."\n";
	print '</head>'."\n";
	print '<body bgcolor="'."$bgcolor".'">'."\n";
	print '<center>'."\n";
	print '<h2 align="center"><font color="#555555">Boo Password Manager</font></h2>'."\n";
	print '<table width="550" cellspacing="10" cellpadding="5">'."\n";
	print '<tr><td width="50%" bgcolor="'."$tdbgcolor".'" valign="top">'."\n";
	print '<form action="./bpm.cgi" method="POST">'."\n";
	print '<font color="#666666">'."\n";
	print ' [Uo^<br><br>'."\n";
	print '<table>'."\n";
	print '<tr><td><font color="#666666">[Uhc</font></td><td><font color="#666666">F</font><input type=text size=10 name=id></td></tr>'."\n";
	print '<tr><td><font color="#666666">[UpX[h</font></td><td><font color="#666666">F</font><input type=text size=10 name=pass></td></tr>'."\n";
	print '</table>'."\n";
	print '<br>'."\n";
	print 'Ǘ҃pX[hF<input type="text" size="10" name="adpass">'."\n";
	print '<br><br>@@@'."\n";
	print '<input type="reset" name="reset" value="Zbg">@@@'."\n";
	print '<input type="submit" name="regist" value="o@^">'."\n";
	print '</font>'."\n";
	print '</form>'."\n";
	print '</td><td bgcolor="'."$tdbgcolor".'" valign="top">'."\n";
	print '<form action="./bpm.cgi" method="POST">'."\n";
	print '<font color="#666666">'."\n";
	print ' [UpX[hύX<br><br>'."\n";
	print '<table>'."\n";
	print '<tr><td><font color="#666666">[Uhc</font></td><td><font color="#666666">F</font><input type=text size=10 name=id></td></tr>'."\n";
	print '<tr><td><font color="#666666">[UpX[h</font></td><td><font color="#666666">F</font><input type=text size=10 name=pass></td></tr>'."\n";
	print '</table>'."\n";
	print '<br>'."\n";
	print 'Ǘ҃pX[hF<input type="text" size="10" name="adpass">'."\n";
	print '<br><br>@@@'."\n";
	print '<input type="reset" name="reset" value="Zbg">@@@'."\n";
	print '<input type="submit" name="change" value="ρ@X">'."\n";
	print '</font>'."\n";
	print '</form>'."\n";
	print '</td></tr>'."\n";
	print '<tr><td colspan="2" bgcolor="'."$tdbgcolor".'" valign="top">'."\n";
	print '<form action="./bpm.cgi" method="POST">'."\n";
	print '<font color="#666666">'."\n";
	print ' [U폜<br><br>'."\n";
	print 'Ǘ҃pX[hF<input type="text" size="10" name="adpass">'."\n";
	print '<br><br>@@@'."\n";
	print '<input type="reset" name="reset" value="Zbg">@@@'."\n";
	print '<input type="submit" name="remove" value="@">'."\n";
	print '<br><br>'."\n";
	print '<center>'."\n";
	print '<table width="100%"><tr><td>'."\n";
	print '<font color="#666666">'."\n";
	print '<table width="100%"><tr>'."\n";
	open (USER,"$htpasswd");
	@user = <USER>;
	close (USER);
	$ui = 0;
	if($sortid eq 'abc'){
		@user = map{$_->[0]} sort{$a->[1] cmp $b->[1]} map{[$_,(split /,/)[0]]} @user; 
	}
	elsif($sortid eq 'cba'){
		@user = map{$_->[0]} sort{$b->[1] cmp $a->[1]} map{[$_,(split /,/)[0]]} @user; 
	}
	elsif($sortid eq '321'){
		@user = reverse(@user);
	}

	foreach $user(@user){
		if($user ne "\n"){
			$ui++;
			($id,$cpass) = split(/:/,$user);
			if($ui < $oneline){
				print '<td><input type="checkbox" name="',"$id",'" value="on"> ',"$id",'</td>'."\n";
			}
			else{
				print '<td><input type="checkbox" name="',"$id",'" value="on"> ',"$id",'</td>',"\n",'</tr>',"\n",'<tr>'."\n";
				$ui = 0;
			}
		}
	}
	print '</tr></table>'."\n";
	print '</font>'."\n";
	print '</td></tr></table>'."\n";
	print '</center>'."\n";
	print '</font>'."\n";
	print '</form>'."\n";
	print '</td></tr>'."\n";
	print '<tr><td colspan="2">'."\n";
	print '<font size="2"><div align="right">Produced by <a href="http://www.booboo.ne.jp/">BooBooClub</a></div></font>'."\n";
	print '</td></tr>'."\n";
	print '</table>'."\n";
	print '</center>'."\n";
	print '</body>'."\n";
	print '</html>'."\n";
	unlink("$lockfile"); 
	exit 0;
}



sub error {
	print "Content-type: text/html\n\n";
	print '<html><head>'."\n";
	print '<meta http-equiv="content-type" content="text/html; charset=Shift_JIS">'."\n";
	print '<title>Error</title></head>'."\n";
	print '<body bgcolor="'."$bgcolor".'" text="#555555"><center>'."\n";
	print '<br><br><br><br><br><h2>Error!</h2><br><br><br>'."\n";
	print 'hcpX[h̕ɖ肪܂<br><br>uEŨobN{^Ŗ߂ĂB'."\n";
	print '<br></center></body></html>'."\n";
	unlink("$lockfile"); 
	exit 0;
}


sub passreg_error{
	print "Content-type: text/html\n\n";
	print '<html><head>'."\n";
	print '<meta http-equiv="content-type" content="text/html; charset=Shift_JIS">'."\n";
	print '<title>Error</title></head>'."\n";
	print '<body bgcolor="'."$bgcolor".'" text="#222222"><center>'."\n";
	print '<br><br><br><br><br><h2>Error!</h2><br><br><br>'."\n";
	print 'G[܂B<br><br>uEŨobN{^Ŗ߂ĂB'."\n";
	print '<br></center></body></html>'."\n";
	unlink("$lockfile"); 
	exit 0;
}



sub pass_error {
	print "Content-type: text/html\n\n";
	print '<html><head>'."\n";
	print '<meta http-equiv="content-type" content="text/html; charset=Shift_JIS">'."\n";
	print '<title>Error</title></head>'."\n";
	print '<body bgcolor="'."$bgcolor".'" text="#555555"><center>'."\n";
	print '<br><br><br><br><br><h2>Error!</h2><br><br><br>'."\n";
	print 'pX[hsł<br><br>uEŨobN{^Ŗ߂ĂB'."\n";
	print '<br></center></body></html>'."\n";
	unlink("$lockfile"); 
	exit 0;
}


sub lock{
	$lockfile = './lock/lockfile';
	$retry = 1;
	until (symlink("$$", "$lockfile")){
		if (++$retry >= 30){
			unlink("$lockfile"); 
			exit 0;
		}
		sleep(1);
	}
}

